package com.jiuqi.util;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.List;

/* loaded from: com_jiuqi_util.jar:com/jiuqi/util/BitMatrix.class */
public class BitMatrix {
    private List bits = new ArrayList();

    public void clear() {
        for (int i = 0; i < this.bits.size(); i++) {
            this.bits.set(i, null);
        }
    }

    public boolean get(int x, int y) {
        BitSet bs = y < this.bits.size() ? (BitSet) this.bits.get(y) : null;
        if (bs == null || x >= bs.size()) {
            return false;
        }
        return bs.get(x);
    }

    public void set(int x, int y, boolean value) {
        while (this.bits.size() <= y) {
            this.bits.add(null);
        }
        BitSet bs = (BitSet) this.bits.get(y);
        if (bs == null) {
            if (!value) {
                return;
            }
            bs = new BitSet();
            this.bits.set(y, bs);
        }
        if (!value) {
            bs.clear(x);
        } else {
            bs.set(x);
        }
    }

    public boolean hasTrue(int y) {
        BitSet bs;
        if (y >= this.bits.size() || (bs = (BitSet) this.bits.get(y)) == null) {
            return false;
        }
        try {
            Class[] parameterTypes = {Integer.TYPE};
            Method nextSetBit = bs.getClass().getMethod("nextSetBit", parameterTypes);
            if (nextSetBit != null) {
                Object[] parameters = {new Integer(0)};
                return ((Integer) nextSetBit.invoke(bs, parameters)).intValue() >= 0;
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        for (int i = 0; i < bs.size(); i++) {
            if (bs.get(i)) {
                return false;
            }
        }
        return true;
    }

    public static void main(String[] args) {
        BitMatrix bm = new BitMatrix();
        bm.set(100, 1, true);
        System.out.println(bm.hasTrue(0));
        System.out.println(bm.hasTrue(1));
    }
}
